% Author: Ehsan
% Date: 2004/11/30

% Unifies if size of the list L is N
  listsize([] , 0).
  listsize([_|L] , N):- listsize(L , F) , N is F+1.

% L is the rest of the list and first element of the list
  delfirst([X|L] , L , X).

% Extracts first column of the two dimentional matrix.
  dfrow([X|[]] , [D] , [B]) :- delfirst(X , D , B).
  dfrow([X | L] , [D|LL] , [A|B]) :- dfrow( L , LL , B) , delfirst(X , D , A).

% Find the transposed matrix
  tp([X|R] , [T] ) :- listsize(X ,1) , dfrow([X|R] , _ , T).
  tp(A , [FR | R]) :- dfrow(A , REST , FR) , tp(REST , R).

% Generates all possible tables which Compact list of them is [R|Rows]
  finalrows([] , [] ,_).
  finalrows([R|Rows] , [T|Table] ,M) :- distribute(R , M ,T ),
                                        finalrows(Rows , Table ,M).

% Generates all possible tables which Compact list of them is [R|Rows]
  finalrows2([] , [] ,_).
  finalrows2([R|Rows] , [T|Table] ,M) :- compact(T ,R ),
                                        finalrows2(Rows , Table ,M).

% Merge
  cols(Cols , Table , M) :- tp(Table , T) ,  finalrows2(Cols , T , M)   .

  final(Rows , Cols , Table) :- listsize(Cols , RLen) , listsize(Rows , CLen) ,
                              finalrows(Rows , Table , RLen) , cols(Cols , Table , CLen),
                              print('\nThe result is:\n'), print(Table), print('\n').

